<?php

function hc($c) {
  $l = strlen($c);
  $n = strspn($c, "0123456789abcdefABCDEF");
  return ($l == $n) ? '#'.$c : $c;
}

$cache = isset($_REQUEST["cache"]) ? $_REQUEST["cache"] : "no";

$w = isset($_REQUEST["w"]) ? $_REQUEST["w"] : 80;
$h = isset($_REQUEST["h"]) ? $_REQUEST["h"] : 80;
$col1 = isset($_REQUEST["c1"]) ? hc($_REQUEST["c1"]) : "#73AEE5";
$col2 = isset($_REQUEST["c2"]) ? hc($_REQUEST["c2"]) : "#003C74";
$algo = isset($_REQUEST["algo"]) ? $_REQUEST["algo"] : "radial-gradient";
$angle = isset($_REQUEST["ang"]) ? $_REQUEST["ang"] : "0";
$opaq = isset($_REQUEST["opaq"]) ? $_REQUEST["opaq"] : "100";

$background = "transparent";

if($angle % 90) {
  function wrad($deg) {
    if($deg < 0) $deg = 360 + $deg % 360;
    return deg2rad($deg%90);
  }
  $fac = sin(wrad($angle)) + cos(wrad($angle));
  $cw = $ch = max($w, $h) * $fac;
} else if($angle % 180) {
  // swap w and h
  $cw = $h;
  $ch = $w;
} else {
  $cw = $w;
  $ch = $h;
}

//$cachefile = 'path/to/your/cachefile.png';
//if (!file_exists($cachefile)) {

	try{

		$canvas = new Imagick();
		$canvas->newImage($cw, $ch, $background, "png");

		$gradient = new Imagick();
		$gradient->newPseudoImage($cw, $ch, "${algo}:".$col1."-".$col2);
		$canvas->compositeImage( $gradient, imagick::COMPOSITE_OVER, 0, 0 );
		/*$canvas->compositeImage( $gradient, imagick::COMPOSITE_OVER, 0, 0, imagick::CHANNEL_BLACK );
		/*
		  imagick::CHANNEL_UNDEFINED (integer)
		  imagick::CHANNEL_RED (integer)
		  imagick::CHANNEL_GRAY (integer)
		  imagick::CHANNEL_CYAN (integer)
		  imagick::CHANNEL_GREEN (integer)
		  imagick::CHANNEL_MAGENTA (integer)
		  imagick::CHANNEL_BLUE (integer)
		  imagick::CHANNEL_YELLOW (integer)
		  imagick::CHANNEL_ALPHA (integer)
		  imagick::CHANNEL_OPACITY (integer)
		  imagick::CHANNEL_MATTE (integer)
		  imagick::CHANNEL_BLACK (integer)
		  imagick::CHANNEL_INDEX (integer)
		  imagick::CHANNEL_ALL (integer)
		  imagick::CHANNEL_DEFAULT (integer) 
		 */		
		$canvas->rotateImage($background, $angle);
		if($col1 != 'transparent' && $col2 != 'transparent')
		  $canvas->setImageOpacity((.0+$opaq)/100);

		if($angle % 90) {
		  if(imagick::getVersion()[versionNumber] < 1655) {
		    $cw = $canvas->getImageWidth();
		    $ch = $canvas->getImageHeight();
		  }
		  $x = ($cw - $w) / 2;
		  $y = ($ch - $h) / 2;
		  $canvas->cropImage($w, $h, $x, $y);
		}
		
		header( "Content-Type: image/png" );
		echo $canvas;

		//$canvas->writeImage($cachefile);

		$canvas->clear();
		$canvas->destroy();

		$gradient->clear();
		$gradient->destroy();

	}catch(Exception $e){
		echo 'Error: ',  $e->getMessage(), "";
	}

/*
}else{

	$canvas = new Imagick($cachefile);
	header("Content-Type: image/png");
	echo $canvas;

}
*/
?>
